//---------------------------------------------------------------------------
// def.h
//---------------------------------------------------------------------------
#ifndef defH
#define defH
#endif

#define BUFFSIZE 1024

//---------------------------------------------------------------------------
#define S32 signed int
#define U32 unsigned int
#define S16 signed short
#define U16 unsigned short
#define S8  signed char
#define U8  unsigned char

//---------------------------------------------------------------------------
// sio kdok
#define STX 2
#define ETX 3

//---------------------------------------------------------------------------
/* vk_kijelzes  */
#define 	DIGIT_BEM   0
#define 	ANALOG_BEM  0x80

//---------------------------------------------------------------------------
/* vk_kijelzes  */
#define	VK_KIJELZES_STATUS	0
#define	VK_KIJELZES_UZEMMOD	1
#define	VK_KIJELZES_F		2
#define	VK_KIJELZES_IMOTOR	3
#define	VK_KIJELZES_V_A_JEL	4
#define	VK_KIJELZES_M_V_A_JEL	5
#define	VK_KIJELZES_SZ_A_JEL	6
#define	VK_KIJELZES_M_A_JEL	7
#define	VK_KIJELZES_ELL_JEL	8
#define	VK_KIJELZES_AN_BE1	9
#define	VK_KIJELZES_AN_BE2	10	// IMD-nl nincs
#define	VK_KIJELZES_SZAML_1	11
#define	VK_KIJELZES_SZAML_2	12
#define	VK_KIJELZES_C_SZAML	13
#define	VK_KIJELZES_N		14
#define	VK_KIJELZES_N_IFA	15	// IMD-nl nincs
#define	VK_KIJELZES_PFELVETT	16
#define	VK_KIJELZES_UHALOZAT	17
#define	VK_KIJELZES_UDC		18
#define	VK_KIJELZES_UMOTOR	19
#define	VK_KIJELZES_TERMELES	20
#define	VK_KIJELZES_TBORDA	21	// IMD-nl nincs
#define	VK_KIJELZES_UZEMORA1	22
#define	VK_KIJELZES_UZEMORA2	23
#define	VK_KIJELZES_DIG_BE	24
#define	VK_KIJELZES_NYOMATEK	25
#define	VK_KIJELZES_RELEK	26
#define	VK_KIJELZES_MOT_POTI_MODOSITAS 27
#define	VK_KIJELZES_URES_SOR	28

//---------------------------------------------------------------------------
/* vk_DigitBe_kivalaszt   */
#define VK_DIGITBE_KIVALASZT_N		0
#define VK_DIGITBE_KIVALASZT_START_K	1
#define VK_DIGITBE_KIVALASZT_START_NY	2
#define VK_DIGITBE_KIVALASZT_IRANYV	3
#define VK_DIGITBE_KIVALASZT_KUSZAS_N	4
#define VK_DIGITBE_KIVALASZT_KUSZAS_I	5
#define VK_DIGITBE_KIVALASZT_K_HIBA	6
#define VK_DIGITBE_KIVALASZT_NYUGTAZ	7
#define VK_DIGITBE_KIVALASZT_STOP	8
#define VK_DIGITBE_KIVALASZT_KIPOERGES	9
#define VK_DIGITBE_KIVALASZT_DC_FEK	10
#define VK_DIGITBE_KIVALASZT_F_TARTAS	11
#define VK_DIGITBE_KIVALASZT_M_P_FEL	12
#define VK_DIGITBE_KIVALASZT_M_P_LE	13
#define VK_DIGITBE_KIVALASZT_VEZ_SZAB	14
#define VK_DIGITBE_KIVALASZT_PRG_TILT	15
#define VK_DIGITBE_KIVALASZT_PRG_STOP	16
#define VK_DIGITBE_KIVALASZT_PRG_LEP	17
#define VK_DIGITBE_KIVALASZT_AN_CSERE	18	// IMD-nl nincs
#define VK_DIGITBE_KIVALASZT_MODOSITO	19
#define VK_DIGITBE_KIVALASZT_SZAM1_FEL	20
#define VK_DIGITBE_KIVALASZT_SZAM1_LE	21
#define VK_DIGITBE_KIVALASZT_SZAM1_Z	22
#define VK_DIGITBE_KIVALASZT_SZAM2_FEL	23
#define VK_DIGITBE_KIVALASZT_SZAM2_LE	24
#define VK_DIGITBE_KIVALASZT_SZAM2_Z	25
#define VK_DIGITBE_KIVALASZT_IFAPOZ_0	26	// IMD-nl nincs
#define VK_DIGITBE_KIVALASZT_PRG_BE1	27
#define VK_DIGITBE_KIVALASZT_PRG_BE2	28
#define VK_DIGITBE_KIVALASZT_PRG_BE3	29
#define VK_DIGITBE_KIVALASZT_PRG_BE4	30
#define VK_DIGITBE_KIVALASZT_PRG_BE5	31
#define VK_DIGITBE_KIVALASZT_PRG_BE6	32
#define VK_DIGITBE_KIVALASZT_PRG_BE7	33
#define VK_DIGITBE_KIVALASZT_PRG_BE8	34
// #define VK_DIGITBE_KIVALASZT_RS485_REMOTE	35
// #define VK_DIGITBE_KIVALASZT_VARAKOZO	36


//---------------------------------------------------------------------------
/* Analog alapjelek */
#define FrekiAlapjelCmd     1
#define SzabAlapjelCmd      2
#define Pos32AlapjelCmd     3
#define TimeoutAlapjelCmd   4

//---------------------------------------------------------------------------

