//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

#include "def.h"

#define T1SEC 20
#define T250MSEC 5

U8 Pr_sorszam;

int cnt=0;

AnsiString RecMsgBuff;

AnsiString ComStr;

AnsiString BeStr, KiStr;

int RecCnt;

U8 valasz_szelektor;
U16 valasz_ertek;

U8 RecBuff[BUFFSIZE-1]; //vteli buffer
U8 SendBuff[BUFFSIZE-1];// ads buffer

int StartKapcs, StartKapcsOld;
int StartGombOld, StartGomb, StartGombDelay;
int EloreHatra, EloreHatraOld, EloreHatraImpulzusos, EloreHatraDelay;
int KuszasNormalOld, KuszasNormal, KuszasNormalDelay;
int KuszasInverzOld, KuszasInverz, KuszasInverzDelay;
int KulsoHibaOld, KulsoHiba, KulsoHibaDelay;
int NyugtazOld, Nyugtaz, NyugtazDelay;
int StopOld, Stop, StopDelay;
int KiporgesOld, Kiporges, KiporgesDelay;
int DCfekOld, DCfek;
int FtartasOld, Ftartas;
int MotorpotiFelOld, MotorpotiFel, MotorpotiFelDelay;
int MotorpotiLeOld, MotorpotiLe, MotorpotiLeDelay;
int VezSzabOld, VezSzab;
int ProgramTiltasOld, ProgramTiltas;
int ProgramStopOld, ProgramStop;
int ProgramLepOld, ProgramLep, ProgramLepDelay;
int AnalogCsereOld, AnalogCsere;
int ModositasOld, Modositas;
int Szamlalo1FelOld, Szamlalo1Fel, Szamlalo1FelDelay;
int Szamlalo1LeOld, Szamlalo1Le, Szamlalo1LeDelay;
int Szamlalo1ZeroOld, Szamlalo1Zero, Szamlalo1ZeroDelay;
int Szamlalo2FelOld, Szamlalo2Fel, Szamlalo2FelDelay;
int Szamlalo2LeOld, Szamlalo2Le, Szamlalo2LeDelay;
int Szamlalo2ZeroOld, Szamlalo2Zero, Szamlalo2ZeroDelay;
int IfaPoz0Old, IfaPoz0, IfaPoz0Delay;
int Program1Old, Program1;
int Program2Old, Program2;
int Program3Old, Program3;
int Program4Old, Program4;
int Program5Old, Program5;
int Program6Old, Program6;
int Program7Old, Program7;
int Program8Old, Program8;

int AnalogValue, AnalogValueOld;
int AnalogValueSelOld, AnalogValueSel;

U8 lekerdezes_szelektor;

extern int ComInit(char * port, unsigned long speed);
extern void ComFlush();
extern void SendMulti(char * buf, unsigned cnt);
extern int Rec();

char imd;
U8 tizpont;

void SendMsg(int analog, int cmd, U32 value);
void RecMsg();

//---------------------------------------------------------------------------
typedef struct { char * kijszoveg; U8 TPx; char * mertekegyseg; } KIJ;

const KIJ kij_IMD[] = {
{ "Sttusz", 0, "" }, // Sttusz
{ "zemmd", 0, "" }, // zemmd
{ "frekvencia", 1, "Hz" }, // freki
{ "Imotor", 1, "A" }, // Imotor
{ "vezrls alapjel", 1, "Hz" }, // vezrls alapjel
{ "mdostott vez. alapjel", 1, "Hz" }, // mdostott vez. alapjel
{ "szablyozs alapjel", 2, "%" }, // szablyozs alapjel
{ "mdostott szab. alapjel", 2, "%" }, // mdostott szab. alapjel
{ "ellenrz jel", 2, "%" }, // ellenrz jel
{ "An. BE1", 0, "" }, // An. BE1
// { "An. BE2", 0, "" }, // An. BE2
{ "szmll 1", 0, "" }, // szmll 1
{ "szmll 2", 0, "" }, // szmll 2
{ "ciklus szmll", 0, "" }, // ciklus szmll
{ "fordulatszm", 0, "rpm" }, // fordulatszm
// { "IFA fordulatszm", 0, "rpm" }, // IFA fordulatszm
{ "Pfelvett", 2, "kW" }, // Pfelvett
{ "Uhlzat", 0, "V" }, // Uhlzat
{ "Udc", 0, "V" }, // Udc
{ "Umotor", 1, "V" }, // Umotor
{ "termels", 1, "" }, // termels
// { "Tborda", 0, "C" }, // Tborda
{ "zemra1", 0, "ra" }, // zemra1
{ "zemra2", 0, "ra" }, // zemra2
{ "Dig. bemenetek", 0, "" }, // Dig. bemenetek
{ "Nyomatk", 0, "Nm" }, // Nyomatk
{ "Relk", 0, "" }, // Relk
{ "mdostott mot. poti.", 0, "" }}; // mdostott mot. poti.

const KIJ kij_nem_IMD[] = {
{ "Sttusz", 0, "" }, // Sttusz
{ "zemmd", 0, "" }, // zemmd
{ "frekvencia", 1, "Hz" }, // freki
{ "Imotor", 1, "A" }, // Imotor
{ "vezrls alapjel", 1, "Hz" }, // vezrls alapjel
{ "mdostott vez. alapjel", 1, "Hz" }, // mdostott vez. alapjel
{ "szablyozs alapjel", 2, "%" }, // szablyozs alapjel
{ "mdostott szab. alapjel", 2, "%" }, // mdostott szab. alapjel
{ "ellenrz jel", 2, "%" }, // ellenrz jel
{ "An. BE1", 0, "" }, // An. BE1
{ "An. BE2", 0, "" }, // An. BE2
{ "szmll 1", 0, "" }, // szmll 1
{ "szmll 2", 0, "" }, // szmll 2
{ "ciklus szmll", 0, "" }, // ciklus szmll
{ "fordulatszm", 0, "rpm" }, // fordulatszm
{ "IFA fordulatszm", 0, "rpm" }, // IFA fordulatszm
{ "Pfelvett", 2, "kW" }, // Pfelvett
{ "Uhlzat", 0, "V" }, // Uhlzat
{ "Udc", 0, "V" }, // Udc
{ "Umotor", 1, "V" }, // Umotor
{ "termels", 1, "" }, // termels
{ "Tborda", 0, "C" }, // Tborda
{ "zemra1", 0, "ra" }, // zemra1
{ "zemra2", 0, "ra" }, // zemra2
{ "Dig. bemenetek", 0, "" }, // Dig. bemenetek
{ "Nyomatk", 0, "Nm" }, // Nyomatk
{ "Relk", 0, "" }, // Relk
{ "mdostott mot. poti.", 0, "" }}; // mdostott mot. poti.


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
ComStr = "COM1";
StatusBar1->Panels->Items[0]->Text = ComStr;
}
//---------------------------------------------------------------------------
void TForm1::Adatfeltoltes()
{
int i;
ComboBox1->Items->Clear();
if (ComboBox4->ItemIndex) //ISD, ILD, IHD
        {
        CheckBox18->Visible=true;
        CheckBox26->Visible=true;
        for (i=0;i<28;i++)
                ComboBox1->Items->Add(kij_nem_IMD[i].kijszoveg);
        }
else                      //IMD
        {
        CheckBox18->Visible=false;
        CheckBox26->Visible=false;
        for (i=0;i<25;i++)
                ComboBox1->Items->Add(kij_IMD[i].kijszoveg);
        }
imd = 1-ComboBox4->ItemIndex;
ComboBox1->ItemIndex=2;
}

//---------------------------------------------------------------------------
AnsiString AsciiToHex(unsigned char kar)
{
AnsiString as="xx ";
char fb,ab;

fb = kar >> 4;
ab = kar & 0x0f;
fb += '0';
if (fb>'9')
 fb += 'A' - '0' - 10;

ab += '0';
if (ab>'9')
   ab += 'A' - '0' - 10;

   as[1]=fb;
   as[2]=ab;

return as;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
S32 S32tmp;

if (cnt==0)
  {
  ComInit("COM1", 38400);

  ComboBox1->ItemIndex = 2; // valasz szelektor

  ComboBox2->ItemIndex = 0; // analog ertek szelektor
  S32tmp = 0;
  Label1->Caption = FloatToStrF((float)S32tmp / 10.0, ffFixed, 3, 1) + "Hz";

  ComboBox3->ItemIndex = 0; // Pr_sorszam
  Pr_sorszam = 1;

  StartKapcsOld = StartKapcs = 0;
  StartGombOld = StartGomb = 0;
  EloreHatraOld = EloreHatra = 0;
  KuszasNormalOld = KuszasNormal = 0;
  KuszasInverzOld = KuszasInverz = 0;
  KulsoHibaOld = KulsoHiba = 0;
  NyugtazOld = Nyugtaz = 0;
  StopOld = Stop = 0;
  KiporgesOld = Kiporges = 0;
  DCfekOld = DCfek = 0;
  FtartasOld = Ftartas = 0;
  MotorpotiFelOld = MotorpotiFel = 0;
  MotorpotiLeOld = MotorpotiLe = 0;
  VezSzabOld = VezSzab = 0;
  ProgramTiltasOld = ProgramTiltas = 0;
  ProgramStopOld = ProgramStop = 0;
  ProgramLepOld = ProgramLep = 0;
  AnalogCsereOld = AnalogCsere = 0;
  ModositasOld = Modositas = 0;
  Szamlalo1FelOld = Szamlalo1Fel = 0;
  Szamlalo1LeOld = Szamlalo1Le = 0;
  Szamlalo1ZeroOld = Szamlalo1Zero = 0;
  Szamlalo2FelOld = Szamlalo2Fel = 0;
  Szamlalo2LeOld = Szamlalo2Le = 0;
  Szamlalo2ZeroOld = Szamlalo2Zero = 0;
  IfaPoz0Old = IfaPoz0 = 0;
  Program1Old = Program1 = 0;
  Program2Old = Program2 = 0;
  Program3Old = Program3 = 0;
  Program4Old = Program4 = 0;
  Program5Old = Program5 = 0;
  Program6Old = Program6 = 0;
  Program7Old = Program7 = 0;
  Program8Old = Program8 = 0;

  AnalogValueOld = AnalogValue;
  }
else
  {
  StatusBar1->Panels->Items[1]->Text = "TX: " + IntToStr(cnt);
  StatusBar1->Panels->Items[2]->Text = "RX: " + IntToStr(RecCnt);
  StatusBar1->Panels->Items[3]->Text = "TX-RX: " +IntToStr(cnt-RecCnt);

  RecMsg();

  Pr_sorszam = ComboBox3->ItemIndex + 1;

  lekerdezes_szelektor = ComboBox1->ItemIndex;
/*
  if (CheckBox35->Checked)
    {
    ComboBox1->Enabled = true;
    Label2->Visible = true;
    lekerdezes_szelektor = ComboBox1->ItemIndex;
    }
  else
    {
    ComboBox1->Enabled = false;
    Label2->Visible = false;
    lekerdezes_szelektor = 0;
    RecCnt = 0;
    }
*/
  StartKapcs = CheckBox1->Checked;
  StartGomb = CheckBox2->Checked;
  EloreHatra = CheckBox3->Checked;
  EloreHatraImpulzusos = CheckBox36->Checked;
  KuszasNormal = CheckBox4->Checked;
  KuszasInverz = CheckBox5->Checked;
  KulsoHiba = CheckBox6->Checked;
  Nyugtaz = CheckBox7->Checked;
  Stop = CheckBox8->Checked;
  Kiporges = CheckBox9->Checked;
  DCfek = CheckBox10->Checked;
  Ftartas = CheckBox11->Checked;
  MotorpotiFel = CheckBox12->Checked;
  MotorpotiLe = CheckBox13->Checked;
  VezSzab = CheckBox14->Checked;
  ProgramTiltas = CheckBox15->Checked;
  ProgramStop = CheckBox16->Checked;
  ProgramLep = CheckBox17->Checked;
  AnalogCsere = CheckBox18->Checked;
  Modositas = CheckBox19->Checked;
  Szamlalo1Fel = CheckBox20->Checked;
  Szamlalo1Le = CheckBox21->Checked;
  Szamlalo1Zero = CheckBox22->Checked;
  Szamlalo2Fel = CheckBox23->Checked;
  Szamlalo2Le = CheckBox24->Checked;
  Szamlalo2Zero = CheckBox25->Checked;
  IfaPoz0 = CheckBox26->Checked;
  Program1 = CheckBox27->Checked;
  Program2 = CheckBox28->Checked;
  Program3 = CheckBox29->Checked;
  Program4 = CheckBox30->Checked;
  Program5 = CheckBox31->Checked;
  Program6 = CheckBox32->Checked;
  Program7 = CheckBox33->Checked;
  Program8 = CheckBox34->Checked;

  AnalogValueSel = ComboBox2->ItemIndex;
  AnalogValue = TrackBar1->Position;

  if (StartKapcsOld != StartKapcs)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_START_K, StartKapcs);
    StartKapcsOld = StartKapcs;
    }
  else if (StartGombOld != StartGomb)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_START_NY, StartGomb);
    StartGombOld = StartGomb;
    StartGombDelay = T1SEC;
    }
  else if (EloreHatraOld != EloreHatra)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_IRANYV, EloreHatra);
    EloreHatraOld = EloreHatra;
    EloreHatraDelay = T1SEC;
    }
  else if (KuszasNormalOld != KuszasNormal)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_KUSZAS_N, KuszasNormal);
    KuszasNormalOld = KuszasNormal;
    KuszasNormalDelay = T250MSEC;
    }
  else if (KuszasInverzOld != KuszasInverz)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_KUSZAS_I, KuszasInverz);
    KuszasInverzOld = KuszasInverz;
    KuszasInverzDelay = T250MSEC;
    }
  else if (KulsoHibaOld != KulsoHiba)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_K_HIBA, KulsoHiba);
    KulsoHibaOld = KulsoHiba;
    KulsoHibaDelay = T1SEC;
    }
  else if (NyugtazOld != Nyugtaz)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_NYUGTAZ, Nyugtaz);
    NyugtazOld = Nyugtaz;
    NyugtazDelay = T1SEC;
    }
  else if (StopOld != Stop)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_STOP, Stop);
    StopOld = Stop;
    StopDelay = T1SEC;
    }
  else if (KiporgesOld != Kiporges)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_KIPOERGES, Kiporges);
    KiporgesOld = Kiporges;
    KiporgesDelay = T1SEC;
    }
  else if (DCfekOld != DCfek)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_DC_FEK, DCfek);
    DCfekOld = DCfek;
    }
  else if (FtartasOld != Ftartas)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_F_TARTAS, Ftartas);
    FtartasOld = Ftartas;
    }
  else if (MotorpotiFelOld != MotorpotiFel)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_M_P_FEL, MotorpotiFel);
    MotorpotiFelOld = MotorpotiFel;
    MotorpotiFelDelay = T250MSEC;
    }
  else if (MotorpotiLeOld != MotorpotiLe)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_M_P_LE, MotorpotiLe);
    MotorpotiLeOld = MotorpotiLe;
    MotorpotiLeDelay = T250MSEC;
    }
  else if (VezSzabOld != VezSzab)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_VEZ_SZAB, VezSzab);
    VezSzabOld = VezSzab;
    }
  else if (ProgramTiltasOld != ProgramTiltas)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_PRG_TILT, ProgramTiltas);
    ProgramTiltasOld = ProgramTiltas;
    }
  else if (ProgramStopOld != ProgramStop)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_PRG_STOP, ProgramStop);
    ProgramStopOld = ProgramStop;
    }
  else if (ProgramLepOld != ProgramLep)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_PRG_LEP, ProgramLep);
    ProgramLepOld = ProgramLep;
    ProgramLepDelay = T1SEC;
    }
  else if (AnalogCsereOld != AnalogCsere)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_AN_CSERE, AnalogCsere);
    AnalogCsereOld = AnalogCsere;
    }
  else if (ModositasOld != Modositas)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_MODOSITO-1 : VK_DIGITBE_KIVALASZT_MODOSITO, Modositas);
    ModositasOld = Modositas;
    }
  else if (Szamlalo1FelOld != Szamlalo1Fel)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_SZAM1_FEL-1 : VK_DIGITBE_KIVALASZT_SZAM1_FEL, Szamlalo1Fel);
    Szamlalo1FelOld = Szamlalo1Fel;
    Szamlalo1FelDelay = T1SEC;
    }
  else if (Szamlalo1LeOld != Szamlalo1Le)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_SZAM1_LE-1 : VK_DIGITBE_KIVALASZT_SZAM1_LE, Szamlalo1Le);
    Szamlalo1LeOld = Szamlalo1Le;
    Szamlalo1LeDelay = T1SEC;
    }
  else if (Szamlalo1ZeroOld != Szamlalo1Zero)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_SZAM1_Z-1 : VK_DIGITBE_KIVALASZT_SZAM1_Z, Szamlalo1Zero);
    Szamlalo1ZeroOld = Szamlalo1Zero;
    Szamlalo1ZeroDelay = T1SEC;
    }
  else if (Szamlalo2FelOld != Szamlalo2Fel)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_SZAM2_FEL-1 : VK_DIGITBE_KIVALASZT_SZAM2_FEL, Szamlalo2Fel);
    Szamlalo2FelOld = Szamlalo2Fel;
    Szamlalo2FelDelay = T1SEC;
    }
  else if (Szamlalo2LeOld != Szamlalo2Le)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_SZAM2_LE-1 : VK_DIGITBE_KIVALASZT_SZAM2_LE, Szamlalo2Le);
    Szamlalo2LeOld = Szamlalo2Le;
    Szamlalo2LeDelay = T1SEC;
    }
  else if (Szamlalo2ZeroOld != Szamlalo2Zero)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_SZAM2_Z-1 : VK_DIGITBE_KIVALASZT_SZAM2_Z, Szamlalo2Zero);
    Szamlalo2ZeroOld = Szamlalo2Zero;
    Szamlalo2ZeroDelay = T1SEC;
    }
  else if (IfaPoz0Old != IfaPoz0)
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_IFAPOZ_0, IfaPoz0);
    IfaPoz0Old = IfaPoz0;
    IfaPoz0Delay = T1SEC;
    }
  else if (Program1Old != Program1)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_PRG_BE1-2 : VK_DIGITBE_KIVALASZT_PRG_BE1, Program1);
    Program1Old = Program1;
    }
  else if (Program2Old != Program2)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_PRG_BE2-2 : VK_DIGITBE_KIVALASZT_PRG_BE2, Program2);
    Program2Old = Program2;
    }
  else if (Program3Old != Program3)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_PRG_BE3-2 : VK_DIGITBE_KIVALASZT_PRG_BE3, Program3);
    Program3Old = Program3;
    }
  else if (Program4Old != Program4)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_PRG_BE4-2 : VK_DIGITBE_KIVALASZT_PRG_BE4, Program4);
    Program4Old = Program4;
    }
  else if (Program5Old != Program5)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_PRG_BE5-2 : VK_DIGITBE_KIVALASZT_PRG_BE5,  Program5);
    Program5Old = Program5;
    }
  else if (Program6Old != Program6)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_PRG_BE6-2 : VK_DIGITBE_KIVALASZT_PRG_BE6, Program6);
    Program6Old = Program6;
    }
  else if (Program7Old != Program7)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_PRG_BE7-2 : VK_DIGITBE_KIVALASZT_PRG_BE7, Program7);
    Program7Old = Program7;
    }
  else if (Program8Old != Program8)
    {
    SendMsg(DIGIT_BEM, imd ? VK_DIGITBE_KIVALASZT_PRG_BE8-2 : VK_DIGITBE_KIVALASZT_PRG_BE8, Program8);
    Program8Old = Program8;
    }

  else if (AnalogValueOld != AnalogValue || AnalogValueSelOld != AnalogValueSel)
    {
    switch (AnalogValueSel)
      { // 0 <= AnalogValue <= 10000
      case 0: // Hz
        S32tmp = (U32)AnalogValue * 1000 / 10000;
        Label1->Caption = FloatToStrF((float)S32tmp / 10.0, ffFixed, 3, 1) + "Hz";
        break;
      case 1: // %
        S32tmp = AnalogValue;
        Label1->Caption = FloatToStrF((float)S32tmp / 100.0, ffFixed, 5, 2) + "%";
        break;
      case 2: // 32bit
        S32tmp = (AnalogValue-5000) * 4096 / 1000;
        Label1->Caption = IntToStr(S32tmp);
        break;
      default: // timeout
        S32tmp = AnalogValue;
        Label1->Caption = FloatToStrF((float)S32tmp / 10.0, ffFixed, 3, 1) + "s";
      }
    SendMsg(ANALOG_BEM, FrekiAlapjelCmd + AnalogValueSel, S32tmp);
    AnalogValueOld = AnalogValue;
    AnalogValueSelOld = AnalogValueSel;
    }
  else
    {
    SendMsg(DIGIT_BEM, VK_DIGITBE_KIVALASZT_N, 0);
    }

  if (StartGombDelay)
    {
    if (--StartGombDelay==0)
      CheckBox2->Checked = false;
    }

  if (EloreHatraImpulzusos)
    if (EloreHatraDelay)
      if (--EloreHatraDelay==0)
        CheckBox3->Checked = false;

  if (KuszasNormalDelay)
    {
    if (--KuszasNormalDelay==0)
      CheckBox4->Checked = false;
    }

  if (KuszasInverzDelay)
    {
    if (--KuszasInverzDelay==0)
      CheckBox5->Checked = false;
    }

  if (KulsoHibaDelay)
    {
    if (--KulsoHibaDelay==0)
      CheckBox6->Checked = false;
    }

  if (NyugtazDelay)
    {
    if (--NyugtazDelay==0)
      CheckBox7->Checked = false;
    }

  if (StopDelay)
    {
    if (--StopDelay==0)
      CheckBox8->Checked = false;
    }

  if (KiporgesDelay)
    {
    if (--KiporgesDelay==0)
      CheckBox9->Checked = false;
    }

  if (MotorpotiFelDelay)
    {
    if (--MotorpotiFelDelay==0)
      CheckBox12->Checked = false;
    }

  if (MotorpotiLeDelay)
    {
    if (--MotorpotiLeDelay==0)
      CheckBox13->Checked = false;
    }

  if (ProgramLepDelay)
    {
    if (--ProgramLepDelay==0)
      CheckBox17->Checked = false;
    }

  if (Szamlalo1FelDelay)
    {
    if (--Szamlalo1FelDelay==0)
      CheckBox20->Checked = false;
    }

  if (Szamlalo1LeDelay)
    {
    if (--Szamlalo1LeDelay==0)
      CheckBox21->Checked = false;
    }

  if (Szamlalo1ZeroDelay)
    {
    if (--Szamlalo1ZeroDelay==0)
      CheckBox22->Checked = false;
    }

  if (Szamlalo2FelDelay)
    {
    if (--Szamlalo2FelDelay==0)
      CheckBox23->Checked = false;
    }

  if (Szamlalo2LeDelay)
    {
    if (--Szamlalo2LeDelay==0)
      CheckBox24->Checked = false;
    }

  if (Szamlalo2ZeroDelay)
    {
    if (--Szamlalo2ZeroDelay==0)
      CheckBox25->Checked = false;
    }

  if (IfaPoz0Delay)
    {
    if (--IfaPoz0Delay==0)
      CheckBox26->Checked = false;
    }
  }
cnt++;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
ComFlush();
}
//---------------------------------------------------------------------------
/* A tvirnyts protokollja:
	Radat[0]:	'T',
	Radat[1]:	cm az RS485 vonalon (1-16, 0 mindenkinek szl),
	Radat[2]:	lekrdezs szelektor, ha a cm==0 vagy a szelektor==0, akkor nincs vlasz
 																	d7-d6: tartalk,
 																	d5-d0: 1-25: a kijelzsi kpben kivlaszthat mennyisgek,
 	Radat[3]:	bemenet szelektor:	d7=0 dig. bemenet
 																	d6=rtk,
 																	d5-d0: 0: nincs dig. bem., 1-36: a standard dig. bem. funkcik
 																d7=1 analg bemenet:
 																	d6=0,
 																	d5-d0: 0 - nincs funkcio,
																				 1 - vez.alapjel [0.1Hz],
																				 2 - szab.alapjel [0.01%],
																				 3 - poz.alapjel (32bitesen),
																				 4 - timeout id [0.1s],
	Radat[4]:	pozici alapjel ? Hi U16 Hi U8 : Hi U8
	Radat[5]:	pozici alapjel ? Hi U16 Lo U8 : Hi Lo
	Radat[6]:	pozici alapjel ? Lo U16 Hi U8 : nincs ez a bjt
	Radat[7]:	pozici alapjel ? Lo U16 Lo U8 : nincs ez a bjt
	*/
void SendMsg(int analog, int cmd, U32 value)
{
U8 idx = 0;
U8 chksum, i;
U8 prot_len;
U8 input_szelektor;

if (!analog)
  {
  input_szelektor = ((value != 0) << 6) + (cmd & 0x3f);
  prot_len = 4;
  }
else
  {
  input_szelektor = 0x80 + (cmd & 0x3f);
  if (cmd != Pos32AlapjelCmd)
    prot_len = 6;
  else
    prot_len = 8;
  }

SendBuff[idx++] = STX;

SendBuff[idx++] = 0x30 | (prot_len >> 4);
SendBuff[idx++] = 0x30 | (prot_len & 0x0f);

SendBuff[idx++] = 0x30 | ('T' >> 4);
SendBuff[idx++] = 0x30 | ('T' & 0x0f);

SendBuff[idx++] = 0x30 | ((Pr_sorszam >> 4) & 0x0f);
SendBuff[idx++] = 0x30 | (Pr_sorszam & 0x0f);

SendBuff[idx++] = 0x30 | ((lekerdezes_szelektor >> 4) & 0x0f);
SendBuff[idx++] = 0x30 | (lekerdezes_szelektor & 0x0f);

SendBuff[idx++] = 0x30 | ((input_szelektor >> 4) & 0x0f);
SendBuff[idx++] = 0x30 | (input_szelektor & 0x0f);

if (analog)
  {
  if (cmd != Pos32AlapjelCmd)
    {
    SendBuff[idx++] = 0x30 | ((value >> 12) & 0x0f);
    SendBuff[idx++] = 0x30 | ((value >> 8) & 0x0f);
    SendBuff[idx++] = 0x30 | ((value >> 4) & 0x0f);
    SendBuff[idx++] = 0x30 | (value & 0x0f);
    }
  else
    {
    SendBuff[idx++] = 0x30 | ((value >> 28) & 0x0f);
    SendBuff[idx++] = 0x30 | ((value >> 24) & 0x0f);
    SendBuff[idx++] = 0x30 | ((value >> 20) & 0x0f);
    SendBuff[idx++] = 0x30 | ((value >> 16) & 0x0f);
    SendBuff[idx++] = 0x30 | ((value >> 12) & 0x0f);
    SendBuff[idx++] = 0x30 | ((value >> 8) & 0x0f);
    SendBuff[idx++] = 0x30 | ((value >> 4) & 0x0f);
    SendBuff[idx++] = 0x30 | (value & 0x0f);
    }
  }

for (chksum=i=0; i<idx; i++)
  chksum += SendBuff[i];

SendBuff[idx++] = 0x30 | ((chksum >> 4) & 0x0f);
SendBuff[idx++] = 0x30 | (chksum & 0x0f);

SendBuff[idx++] = ETX;

KiStr = "";

for (i=0; i<idx; i++)
  KiStr += AsciiToHex(SendBuff[i]);

if (Form1->Memo1->Lines->Strings[Form1->Memo1->Lines->Count-1] != KiStr)
  Form1->Memo1->Lines->Add(KiStr);

SendMulti(SendBuff, idx);
}
//---------------------------------------------------------------------------
/*
 Vlasz protokoll a tvirnyts zenetre (a frekivlt kldi)
	Tadat[0]:	't'
	Tadat[1]:	cm az RS485 vonalon (1-16),
 	Tadat[2]:	lekrdezs szelektor:,
	Tadat[3]:	pozici alapjel ? Hi U16 Hi U8 : Hi U8
	Tadat[4]:	pozici alapjel ? Hi U16 Lo U8 : Hi Lo
	Tadat[5]:	pozici alapjel ? Lo U16 Hi U8 : nincs ez a bjt
	Tadat[6]:	pozici alapjel ? Lo U16 Lo U8 : nincs ez a bjt
*/
//---------------------------------------------------------------------------
AnsiString HibaStr[] = {
"Trlt!",              // 0
"Kls hiba 1.",        // 1
"Kls hiba 2.",        // 2
"Kls hiba 3.",        // 3
"Kls hiba 4.",        // 4
"Kls hiba 5.",        // 5
"Kls hiba 6.",        // 6
"Kls hiba 7.",        // 7
"Komp. hiba 1.",        // 8
"Komp. hiba 2.",        // 9
"Komp. hiba 3.",        // 10
"Kls hiba 11.",       // 11
"Motor tlmeleg",       // 12
"Motor tlram",        // 13
"Nincs motor",          // 14
"Fzis szakadt",        // 15
"Fk tlterhels",      // 16
"Hl. fzis hiba",      // 17
"Borda tl hideg",      // 18
"Borda tl meleg",      // 19
"Tlram U.fzis",      // 20
"Tlram V.fzis",      // 21
"Tlram W.fzis",      // 22
"IGBT vdelem",         // 23
"HW fesz. vdelem",     // 24
"DC tlfeszltsg",     // 25
"Tlfrekvencia",        // 26
"Iu mrsi hiba",       // 27
"Iv mrsi hiba",       // 28
"Iw mrsi hiba",       // 29
"EEPROM hiba",          // 30
"SW hiba 1.",           // 31
"SW hiba 2.",           // 32
"Terminl hiba",        // 33
"RS485 hiba",           // 34
"IIC hiba",             // 35
"Terminl vsz ki",     // 36
"Alapjel hiba",         // 37
"Ell. jel hiba",        // 38
"Par.hiba An.BE1.",     // 39
"Par.hiba An.BE2.",     // 40
"Par.hiba 3.",          // 41
"DC fesz.hullmos",     // 42
"PIC hiba",             // 43
"Tlprgs",            // 44
"CAN hiba",             // 45
"Ismeretlen hiba!",     // 46
};
//---------------------------------------------------------------------------
AnsiString StatuszStr[] = {
" zz     ",
"       1",
"       2",
"       3",
"RepStart",
"       5",
"       6",
"       7",
"       8",
"       9",
"      10",
"      11",
"      12",
"RrAdapt!",
"mot.poti",
"Gen.zem",
"I limit ",
"U DC lim",
"Id Prg.",
"Program ",
"  R fk ",
"Vrakoz",
"Komp.Stp",
"Potm.Stp",
"Szm.Stp",
" Kszs ",
"f tarts",
"  Lell ",
"Kiprgs",
" DC fk ",
"  Stop  ",
"  U DC< ",
"! Hiba !",
};
//---------------------------------------------------------------------------
AnsiString LogVezForrasaStr[] = {
"terminl",
"s.kapocs",
"term/sk.",
"RS485tv",
"     CAN",
};
//---------------------------------------------------------------------------
void RecMsg()
{
char * src;
AnsiString str, megyseg = "";
int i;
int bejott_adatok_db;

        bejott_adatok_db = Rec();
//        if(bejott_adatok_db != 16) Beep();
        Form1->StatusBar1->Panels->Items[4]->Text = "J: " + IntToStr(bejott_adatok_db);
if (bejott_adatok_db > 0)
  {
  if (RecBuff[0]==STX &&
      RecBuff[1]==0x30 &&
      RecBuff[2]==0x35 && // prot_len
      RecBuff[3]==(0x30 | ('t' >> 4)) &&
      RecBuff[4]==(0x30 | ('t' & 0x0f)) && // 't'
      RecBuff[5]==(0x30 | ((Pr_sorszam >> 4) & 0x0f)) &&
      RecBuff[6]==(0x30 | (Pr_sorszam & 0x0f)) && // cim
      (RecBuff[7]&0x30)==0x30 &&
      (RecBuff[8]&0x30)==0x30 && // lekerdezes szelektor
      (RecBuff[9]&0x30)==0x30 &&
      (RecBuff[10]&0x30)==0x30 &&
      (RecBuff[11]&0x30)==0x30 &&
      (RecBuff[12]&0x30)==0x30 && // U16
      RecBuff[15]==ETX)
    {
    valasz_szelektor = ((RecBuff[7]&0x0f)<<4) + (RecBuff[8]&0x0f);
    valasz_ertek = (((U16)(RecBuff[9]&0x0f))<<12) +
                    (((U16)(RecBuff[10]&0x0f))<<8) +
                    ((RecBuff[11]&0x0f)<<4) +
                    (RecBuff[12]&0x0f);

BeStr = "";

for (i=0; i<14;i++)
  BeStr += AsciiToHex(RecBuff[i]);

if (Form1->Memo2->Lines->Strings[Form1->Memo2->Lines->Count-1] != BeStr)
  Form1->Memo2->Lines->Add(BeStr);

if (Form1->ComboBox4->ItemIndex) //ISD, ILD, IHD
        {
        src = kij_nem_IMD[valasz_szelektor].mertekegyseg;
        tizpont = kij_nem_IMD[valasz_szelektor].TPx;
        }
else                      //IMD
        {
        src = kij_IMD[valasz_szelektor].mertekegyseg;
        tizpont = kij_IMD[valasz_szelektor].TPx;
        }
    while (*src != 0)
      megyseg += *src++;
    if (valasz_szelektor==0)
      { // sttusz
      if (valasz_ertek&0x40)
        Form1->Label2->Caption = HibaStr[valasz_ertek&0x3f];
      else
        {
        str = ((valasz_ertek&0x80)==0x80 ? "Megy" : "ll");
        if ((valasz_ertek&0x3f) != 0)
          str += " " + StatuszStr[valasz_ertek&0x3f];
        Form1->Label2->Caption = str;
        }
      }
    else if (valasz_szelektor==1)
      { // uzemmod
      str = ((valasz_ertek&0x80)==0x80 ? "Elre" : "Htra");
      if (valasz_ertek)
        str += " " + LogVezForrasaStr[valasz_ertek&0x3f];
      Form1->Label2->Caption = str;
      }
    else if (tizpont == 0)
      Form1->Label2->Caption = IntToStr(valasz_ertek) + megyseg;
    else if (tizpont == 1)
      Form1->Label2->Caption = FloatToStrF((float)valasz_ertek/10.0, ffFixed, 3, 1) + megyseg;
    else if (tizpont == 2)
      Form1->Label2->Caption = FloatToStrF((float)valasz_ertek/100.0, ffFixed, 3, 2) + megyseg;
    RecCnt++;
    }
  }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::ComboBox4Change(TObject *Sender)
{
  Adatfeltoltes();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Adatfeltoltes();
}
//---------------------------------------------------------------------------




void __fastcall TForm1::Edit1Change(TObject *Sender)
{
        CheckBox35->Checked = false;

        int szam = StrToIntDef(Edit1->Text,50);
        if(szam == 0) szam++;
        if(szam != StrToIntDef(Edit1->Text,70))
        {
                Edit1->Text = IntToStr(szam);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox35Click(TObject *Sender)
{
        if(CheckBox35->Checked) Timer1->Interval = StrToInt(Edit1->Text);
}
//---------------------------------------------------------------------------

